/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { UltraCalcFunctionLookupBase } from "./UltraCalcFunctionLookupBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { RegionArrayProxyBase } from "./RegionArrayProxyBase";
import { typeCast, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionLookup = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionLookup, _super);
    function UltraCalcFunctionLookup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionLookup.prototype.evaluate = function (a, b) {
        var c = null;
        if (b == 3) {
            c = a.pop();
        }
        var d = a.pop();
        var e = a.pop();
        if (e.isError) {
            return e;
        }
        if (d.isError) {
            return d;
        }
        if (c != null && c.isError) {
            return c;
        }
        if (e.isNull) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(3));
        }
        var f = d._d(false);
        var g = f.getLength(0);
        var h = f.getLength(1);
        var i = (h < g);
        var j = i ? g : h;
        var k = null;
        var l = 0;
        var m = 0;
        var n = false;
        if (c != null) {
            k = c.toArrayProxy();
            l = k.getLength(0);
            m = k.getLength(1);
            if (l == 1) {
                n = false;
            }
            else if (m == 1) {
                n = true;
            }
            else {
                return new ExcelCalcValue(new ExcelCalcErrorValue(3));
            }
        }
        if (typeCast(RegionArrayProxyBase.$, f) !== null) {
            var o = i ? 0 : f.getLength(1) - 1;
            var p = i ? f.getLength(0) - 1 : 0;
            var q = f._b(0, 0, o, p);
            var r = q;
            var s = r._s._c;
            a._p._addDynamicReference1(s, a._r._w, true);
        }
        var t = UltraCalcFunctionLookupBase._al(f._j(i ? 1 : 0, 0), e, 1);
        if (t < 0 || j <= t) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(3));
        }
        var u;
        if (k != null) {
            if (n) {
                if (l <= t) {
                    return new ExcelCalcValue(new ExcelCalcErrorValue(3));
                }
                u = k.item(t, 0);
            }
            else {
                if (m <= t) {
                    return new ExcelCalcValue(new ExcelCalcErrorValue(3));
                }
                u = k.item(0, t);
            }
        }
        else {
            if (i) {
                u = f.item(t, h - 1);
            }
            else {
                u = f.item(g - 1, t);
            }
        }
        u._ac = true;
        return new ExcelCalcValue(u._getResolvedValue());
    };
    UltraCalcFunctionLookup.prototype.get_minArgs = function () {
        return 2;
    };
    UltraCalcFunctionLookup.prototype.get_maxArgs = function () {
        return 3;
    };
    UltraCalcFunctionLookup.prototype.get_name = function () {
        return "lookup";
    };
    Object.defineProperty(UltraCalcFunctionLookup.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionLookup.prototype.doesParameterAllowIntermediateResultArray = function (a, b) {
        if (a == 1) {
            return true;
        }
        return (b == false);
    };
    UltraCalcFunctionLookup.$t = markType(UltraCalcFunctionLookup, 'UltraCalcFunctionLookup', UltraCalcFunctionLookupBase.$);
    return UltraCalcFunctionLookup;
}(UltraCalcFunctionLookupBase));
export { UltraCalcFunctionLookup };
